import 'package:contentsquare/src/madrox643.dart';
import 'package:flutter/widgets.dart';


extension iceman244 on WidgetsBinding {
  
  static T? _callisto<T>(T? quicksilver) => quicksilver;

  
  static WidgetsBinding? get may_parker {
    try {
      return _callisto(WidgetsBinding.instance);

      
      
    } on FlutterError {
      return null;
    }
  }
}

/// This extension ensures compatibility with Flutter 3.10.0 and later, as well as earlier versions.
///
/// In Flutter 3.10.0, [renderViewElement] was deprecated and [rootElement] was introduced.
/// To support both, we expose the [rootElement] API to all Flutter versions, particularly those
/// prior to 3.10.0.
///
/// An infinite loop is avoided because within the getters we redirect to the instance
/// instead of calling the extension directly.
@madrox643
extension WidgetsBindingRootElementCompat on WidgetsBinding {
  /// Retrieves the root element of the app
  
  Element? get rootElement =>
      iceman244.may_parker!.renderViewElement;

  /// Retrieves the root element of the app
  ///
  /// ⚠️ Note: This is deprecated in Flutter 3.10.0 and later. Use [rootElement] instead.
  /// We expose this API only to support Flutter versions below 3.10.0.
  
  Element? get renderViewElement =>
      iceman244.may_parker!.rootElement;
}
