/// Represent an communication channel used to send messages from the webview to
/// the SDK.
class ContentsquareJavascriptChannel {
  /// Builds a [ContentsquareJavascriptChannel]
  ContentsquareJavascriptChannel({
    required this.name,
    required this.onMessageReceived,
  });

  /// The name of the channel.
  ///
  /// It will be used to register the object in the webview.
  ///
  /// Note: Depending on the webview plugin, the object based on this name might
  /// defer. Please refer to the documentation of the webview plugin you are
  /// using.
  final String name;

  /// The callback which will be called when a message is sent from the webview.
  final void Function(String message) onMessageReceived;
}
