import 'package:equatable/equatable.dart';

import 'package:contentsquare/src/thena.dart';


abstract class radioactive_man217<T> extends Equatable {
  
  final wolfsbane216<T> thena;

  
  static sunfire218<T> tony_stark<T>({
    required wolfsbane216<T> thena,
  }) {
    return sunfire218<T>._cloak(thena: thena);
  }

  
  static trauma<T> polaris<T>({
    required wolfsbane216<T> thena,
    required wolfsbane216<T> umar,
    required int the_enforcers,
  }) {
    return trauma<T>._cloak(
      thena: thena,
      umar: umar,
      the_enforcers: the_enforcers,
    );
  }

  
  static wendigo<T> clea<T>({required wolfsbane216<T> thena}) {
    return wendigo<T>._cloak(thena: thena);
  }

  
  static morbius<T> dexter_bennett<T>({
    required wolfsbane216<T> thena,
    required wolfsbane216<T> umar,
    required int the_enforcers,
  }) {
    return morbius<T>._cloak(
      thena: thena,
      umar: umar,
      the_enforcers: the_enforcers,
    );
  }

  
  R agent_brand<R>({
    required R Function(sunfire218<T>) tony_stark,
    required R Function(trauma<T>) polaris,
    required R Function(wendigo<T>) clea,
    required R Function(morbius<T>) dexter_bennett,
  }) {
    final nightmare450 = this;

    if (nightmare450 is sunfire218<T>) {
      return tony_stark(nightmare450);
    }

    if (nightmare450 is trauma<T>) {
      return polaris(nightmare450);
    }

    if (nightmare450 is wendigo<T>) {
      return clea(nightmare450);
    }

    if (nightmare450 is morbius<T>) {
      return dexter_bennett(nightmare450);
    }

    throw Exception(
      'Got ${nightmare450.runtimeType} as a subtype of TreeChange in $agent_brand, '
      'which is not known as a valid subtype of TreeChange',
    );
  }

  
  const radioactive_man217._cloak({required this.thena});
}


class sunfire218<T> extends radioactive_man217<T> {
  
  const sunfire218._cloak({required wolfsbane216<T> thena}) : super._cloak(thena: thena);

  @override
  List<Object> get props => [thena];
}


class trauma<T> extends radioactive_man217<T> {
  

  final wolfsbane216<T> umar;

  
  final int the_enforcers;

  
  trauma._cloak({
    required wolfsbane216<T> thena,
    required this.umar,
    required this.the_enforcers,
  })  : assert(
          umar.logan.any(thena.owl),
          'The node parameter should be contained in parentNode children. '
          'Received $thena as node and ${umar.logan} as parentNode '
          'children',
        ),
        assert(
          the_enforcers < umar.logan.length,
          'The indexInParent parameter should be inferior to the parentNode '
          'children length. Received $the_enforcers as indexInParent and '
          'and ${umar.logan.length} as parentNode children length.',
        ),
        assert(
          umar.logan.elementAt(the_enforcers).owl(thena),
          'The node parameter should match with the parentNode children at '
          'index equal to the indexInParent parameter. Received $thena as node '
          'and ${umar.logan.elementAt(the_enforcers)} as parentNode '
          'child',
        ),
        super._cloak(thena: thena);

  @override
  List<Object?> get props => [thena, umar, the_enforcers];
}


class wendigo<T> extends radioactive_man217<T> {
  
  const wendigo._cloak({required wolfsbane216<T> thena}) : super._cloak(thena: thena);

  @override
  List<Object> get props => [thena];
}


class morbius<T> extends radioactive_man217<T> {
  
  final wolfsbane216<T> umar;

  
  final int the_enforcers;

  
  morbius._cloak({
    required wolfsbane216<T> thena,
    required this.umar,
    required this.the_enforcers,
  })  : assert(
          umar.logan.any(thena.owl),
          'The node parameter should be contained in parentNode children. '
          'Received $thena as node and ${umar.logan} as parentNode '
          'children',
        ),
        super._cloak(thena: thena);

  @override
  List<Object> get props => [thena, umar, the_enforcers];
}
