import 'package:contentsquare/contentsquare.dart';

/// Custom variables are used to provide additional information about a page and
/// are provided within [Contentsquare.send].
class CustomVar {
  /// The index of the custom variable.
  ///
  /// Must be between 1 and 20.
  final int index;

  /// The name of the custom variable.
  final String name;

  /// The value of the custom variable.
  final String value;

  /// Creates a new custom variable.
  CustomVar({
    required this.index,
    required this.name,
    required this.value,
  }) : assert(
          index >= 1 && index <= 20,
          'Custom variable index must be between 1 and 20',
        );
}
